<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="users"
    :page="page"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
  >
    <template #item.names="{ item }">
      {{ fullName(item) }}
    </template>
    <template #item.doc="{ item }">
      {{ fullDocument(item) }}
    </template>
    <template #item.role="{ item }">
      {{ roleName(item) }}
    </template>
    <template #item.center="{ item }">
      {{ centerName(item.centerId) }}
    </template>
    <template #item.state="{ item }">
      {{ state(item) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapGetters, mapState } from 'vuex';
import { errorOptions } from '~/helpers/toast';

export default {
  name: 'UsersTable',
  data: () => ({
    loading: false,
    headers: [
      {
        text: 'Nombres',
        align: 'start',
        sortable: false,
        value: 'names',
      },
      {
        text: 'Documento',
        sortable: false,
        value: 'doc',
      },
      {
        text: 'Rol',
        sortable: false,
        value: 'role',
      },
      {
        text: 'Centro de Distribución',
        sortable: false,
        value: 'center',
      },
      {
        text: 'Estado',
        sortable: false,
        value: 'state',
      },
    ],
  }),
  computed: {
    ...mapState({
      users: state => state.company.users.users,
      page: state => state.company.users.pageInfo.page,
      pageSize: state => state.company.users.pageInfo.pageSize,
      total: state => state.company.users.pageInfo.total,
    }),
    ...mapGetters({
      centerFromId: 'company/centers/fromId',
    }),
  },
  async mounted() {
    await this.getUsersData();
  },
  methods: {
    ...mapActions({
      getCenters: 'company/centers/getAllCenters',
      getUsers: 'company/users/getUsers',
    }),
    async getUsersData() {
      this.loading = true;
      try {
        await Promise.all([
          this.getUsers({}),
          this.getCenters(),
        ]);
      } catch (e) {
        this.$toast.error('No se ha podido obtener los usuarios', errorOptions);
      }
      this.loading = false;
    },
    fullName({ names, lastnames }) {
      return `${names} ${lastnames}`;
    },
    fullDocument({ doc: { type, number } }) {
      return `${type} - ${number}`;
    },
    roleName({ role: { name } }) {
      return name;
    },
    state({ active }) {
      return active ? 'ACTIVO' : 'BLOQUEADO';
    },
    centerName(centerId) {
      return this.centerFromId(centerId)?.name ?? '-';
    },
  },
};
</script>
